/*
	file_get_contents in C language
	(C)2009- H.Hiro(Maraigue)
*/

#ifndef _MARAIGUE_GET_CONTENT_C_
#define _MARAIGUE_GET_CONTENT_C_

#include "get_content.hpp"

void * file_get_contents(const char * filename, long * size = NULL){
	int tmp;
	long read_size;
	void * buf;
	FILE *fp = fopen(filename, "rb");
	
	if(fp == NULL){
		/* Failed in opening file */
		return NULL;
	}
	
	/* Find file size */
	if(fseek(fp, 0, SEEK_END)){
		goto exit_by_file_error;
	}
	
	read_size = ftell(fp);
	if(read_size == -1){
		goto exit_by_file_error;
	}
	
	/* Reset file pointer */
	if(fseek(fp, 0, SEEK_SET)){
		goto exit_by_file_error;
	}
	
	/* Import file content to memory */
	buf = malloc(read_size);
	if(buf == NULL){
		goto exit_by_file_error;
	}
	
	if(fread(buf, read_size, 1, fp) != 1){
		free(buf);
		goto exit_by_file_error;
	}
	
	if(size != NULL) *size = read_size;
	
	return buf;
	
exit_by_file_error:
	fclose(fp);
	return NULL;
}

#endif /* _MARAIGUE_GET_CONTENT_C_ */
