#include <stdio.h>
#include <stdlib.h>
#include "tettette.hpp"

// ---------- Show help ----------
void showhelp(void){
	fprintf(stderr, "Tettette Language (Main Part) Ver. "TETTETTE_VERSION);
		fprintf(stderr, " (C)2009- H.Hiro (Maraigue)\n");
	fprintf(stderr, "see: http://kugyu.info/tettette/\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "Usage:\n");
	fprintf(stderr, "    tettette FILE\n");

	exit(1);
}

int main(int argc, char *argv[]){
	int ch;
	TTT_INT16 * source = NULL; // source code
	long source_size;
	
	// ----- Parse command line and read source code -----
 	if(argc <= 1) showhelp();
	
	source = (TTT_INT16 *)file_get_contents(argv[1], &source_size);
	if(source == NULL){
		error("Error: Source code not specified, or can not be opened (%d)", __LINE__);
		return 1;
	}
	if(source_size % 2 == 1){
		error("Error: Source code must be written in UTF-16 little endian (%d)", __LINE__);
		return 1;
	}
	source_size /= 2;
	
	// ----- Run code -----
	Tettette ttt_exec(source, source_size);
	
	free(source);
	return ttt_exec.exec_result;
}
